/* $Id: f2c.java,v 1.6 2011/11/03 05:45:31 mit Exp $ */
/* Frequency Cent Transfer v1.4 */
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.text.DecimalFormat;

public class f2c extends Applet implements ActionListener
{
    private TextField tfCA, tfCQ;
    private TextField tfFA, tfFQ;
    private TextField tfK0;
    private Button btC, btA, btK;
    private Button btM, btm, btp, btP;
    private Button btU, btD;
    private Label lK, lP;

    final int CENT = 1200;
    final int OCTAVE = 12; 
    final int A49 = OCTAVE*4; // 49-1
    final int PITCH = 440;
    final int AOld = 415;
    final int AllKey = 88;
    final String[] KeyName = 
    {"A","B","H","C","Cis","D","Es","E","F","Fis","G","Gis"};
    private static final long serialVersionUID = 1L;

    boolean CP;
    int AA = PITCH;
    int KN = A49;
    int FontSize;
    DecimalFormat df1;
    Font Fnt;

    public void init() {
	FontSize = Integer.parseInt(getParameter("font")); //
	Fnt = new Font("SansSerif", Font.BOLD, FontSize);
	setFont(Fnt);
	setBackground(Color.lightGray);
        setLayout(new BorderLayout());
	df1 = new DecimalFormat("#0.0##");

	int mado = 7;

	Panel n = new Panel();
        n.setLayout(new GridLayout(2,1,0,0));
        add(n, "North");

	Panel n2 = new Panel();
	n2.setLayout(new FlowLayout());
	n.add(n2);

	Panel n1 = new Panel();
	n1.setLayout(new FlowLayout());
	n.add(n1);

	n1.add(new Label("Key#:"));

	lK = new Label("Cis(00)"); // key#
	n1.add(lK);

	btM = new Button(" << ");
        n1.add(btM);
        btM.addActionListener(this);

	btm = new Button(" < ");
        n1.add(btm);
        btm.addActionListener(this);

	btp = new Button(" > ");
        n1.add(btp);
        btp.addActionListener(this);

	btP = new Button(" >> ");
        n1.add(btP);
        btP.addActionListener(this);

	btK = new Button("Reset A(49)");
        n1.add(btK);
        btK.addActionListener(this);
	//---

	n2.add(new Label("Pitch:"));

	lP = new Label("______"); // a49
	n2.add(lP);

	btD = new Button(" - ");
        n2.add(btD);
        btD.addActionListener(this);

	btU = new Button(" + ");
        n2.add(btU);
        btU.addActionListener(this);

	btA = new Button("Change A:"+AOld);
        n2.add(btA);
        btA.addActionListener(this);

	n2.add(new Label("")); // space

	btC = new Button("Calculate");
        n2.add(btC);
        btC.addActionListener(this);
	//--------------------------

	Panel s = new Panel();
	s.setLayout(new FlowLayout());
        add(s, "South");

	Panel s1 = new Panel();
	s1.setLayout(new FlowLayout());
	s.add(s1);

	Panel s2 = new Panel();
	s2.setLayout(new GridLayout(2,1,0,0));
	s.add(s2);

	Panel s3 = new Panel();
	s3.setLayout(new FlowLayout());
	s2.add(s3);

	Panel s4 = new Panel();
	s4.setLayout(new FlowLayout());
	s2.add(s4);
	//---

	tfK0 = new TextField("", mado); // key-freq
        tfK0.setEditable(false);
        s1.add(tfK0);

	s1.add(new Label("[Hz]"));
	//---

	s3.add(new Label(":"));

	tfFQ = new TextField("442", mado); // f-in
        tfFQ.addActionListener(this);
        s3.add(tfFQ);

	s3.add(new Label("[Hz]="));

	tfCA = new TextField("", mado); // f-out(c)
        tfCA.addActionListener(this);
        tfCA.setEditable(false);
	s3.add(tfCA);

	s3.add(new Label("[cent]"));
	//---

	s4.add(new Label("+"));

	tfCQ = new TextField("100", mado); // c-in
        tfCQ.addActionListener(this);
        s4.add(tfCQ);

	s4.add(new Label("[cent]="));

	tfFA = new TextField("", mado); // c-out(f)
        tfFA.addActionListener(this);
        tfFA.setEditable(false);
	s4.add(tfFA);

	s4.add(new Label("[Hz]"));
    }
    public void start() {
	write_text();
    }
    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == btM)      // <<
            ppmm(-OCTAVE);
	else if (e.getSource() == btm) // <
            ppmm(-1);
	else if (e.getSource() == btp) // >
            ppmm(1);
	else if (e.getSource() == btP) // >>
            ppmm(OCTAVE);

 	else if (e.getSource() == btK) // to a49
	    set_akey();

	else if (e.getSource() == btD) // down
	    check_a(false);
	else if (e.getSource() == btU) // up
	    check_a(true);

	if (e.getSource() == btA) // pitch set
	    set_btA();

	write_text();
    }
    public void set_akey() {
	KN = A49;
    }
    public void set_btA() {
	CP = !CP;

	AA = CP ? AOld : PITCH;
	String lb = CP ? "A:"+PITCH : "A:"+AOld;
	btA.setLabel("Change "+lb);  
    }
    public void check_a(boolean sw) {
	AA = sw ? ++AA : --AA;

	if (AA < 0)
	    AA = 1;
    }
    public void ppmm(int n) {
	KN += n;
        if (KN < 0) 
            KN = AllKey+KN;
        else if (KN >= AllKey) 
            KN = KN-AllKey;
    }
    public void write_text() {
	calc();

	lP.setText(dform(getFreq(A49)));
	lK.setText(get_keyname());

	String fr = dform(getFreq(KN));
	tfK0.setText(fr);
    } 
    public void calc() {
	String fq = tfFQ.getText();
	String cq = tfCQ.getText();

	if (fq.equals("")) 
	    tfCA.setText("no input.");
	else {
	    try {
		double fqd = Double.valueOf(fq).doubleValue();
		tfCA.setText(dform(ftoc(fqd)));
	    }
	    catch(NumberFormatException e) {
		tfCA.setText("input error.");
	    }
	}
	if (cq.equals(""))
	    tfFA.setText("no input.");
	else {
	    try {
		double cqd = Double.valueOf(cq).doubleValue();
		tfFA.setText(dform(ctof(cqd)));
	    }
	    catch(NumberFormatException e) {
		tfFA.setText("input error.");
	    }
	}
    }
    public String dform(double n) {
	return df1.format((float)n);
    }
    public double ftoc(double f) {
	return CENT*Math.log(f/getFreq(KN))/Math.log(2);
    }
    public double ctof(double c) {
	return getFreq(KN)*Math.pow(2, c/CENT);
    }
    public double getFreq(int key) {
	return AA*Math.pow(2, (key-48)/(double)OCTAVE); // 0~87
    }
    public String get_keyname() {
        return KeyName[KN%OCTAVE]+"("+(KN+1)+")";
    }
    //
    public void paint(Graphics g) {
	int w = getSize().width;
	int h = getSize().height;
	String t1 = "Frequency to Cent";
	String t2 = "Cent to Frequency";

	int fs = FontSize+6;
	Font f = new Font("Times", Font.BOLD, fs);
	FontMetrics fm = getFontMetrics(f);
	int w1 = fm.stringWidth(t1);
	int w2 = fm.stringWidth(t2);
	int wh = w/2;
	g.setFont(f);

	g.setColor(Color.gray);
        g.fillRect(0, 0, w, h);
	int hc = h/2;
	int x1 = wh-(w1*2/3);
	int x2 = wh-w2/3;
	int y1 = hc;
	int y2 = hc+fs;

	g.setColor(Color.black);
	g.drawString(t1, x1+1, y1+1);
	g.drawString(t2, x2+1, y2+1);

	g.setColor(Color.yellow);
	g.drawString(t1, x1, y1);
	g.drawString(t2, x2, y2);
    }
}
